local mod = ...



-- mod:registerAssetId("models/Terrain1.fbx/Materials/Material.Water", "MATERIAL_TERRAIN_WATER")
-- mod:override({
-- 	Id = "MATERIAL_TERRAIN_WATER",
-- 	HasAlphaTest = true
-- })


-- Materials -------------------------------------------------------------------------------------
mod:registerAssetId("models/Terrace1.fbx/Materials/Material.Dark", "MATERIAL_TERRAIN_DARK")
mod:registerAssetId("models/Terrace1.fbx/Materials/Material.Grass", "MATERIAL_TERRAIN_GRASS")
mod:registerAssetId("models/Terrace1.fbx/Materials/Material.Light", "MATERIAL_TERRAIN_LIGHT")
mod:registerAssetId("models/Terrace1.fbx/Materials/Material.Rock", "MATERIAL_TERRAIN_ROCK")



-- Loop count -------------------------------------------------------------------------------------
_countHill = 15
_countCliff = 5
_countTerrace = 3
_countWall = 4
_countPiling = 3
-- _countPlateau = 1
-- _countWater = 1



-- Function: Terrain -------------------------------------------------------------------------------------
function registerTerrain(_name)

	mod:registerAssetId("models/Terrain1.fbx/Prefab/" .. _name, "PREFAB_BUILDING_PART_TERRAIN_" .. _name)
	mod:registerPrefabComponent("models/Terrain1.fbx/Prefab/" .. _name, { DataType = "COMP_RIGID_BODY", Mass = 0 })
	mod:configurePrefabFlagList("models/Terrain1.fbx/Prefab/" .. _name, { "TERRAIN" })
	
	mod:register({
		DataType = "BUILDING_PART",
		Id = "BUILDING_PART_TERRAIN_" .. _name,
		Name = "BUILDING_PART_TERRAIN_" .. _name .. "_NAME", 
		Category = "CORE", 
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
			CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_" .. _name
		}
	})

end



-- Function: Terrace -------------------------------------------------------------------------------------
function registerTerrace(_name)

	mod:registerAssetId("models/Terrace1.fbx/Prefab/" .. _name, "PREFAB_BUILDING_PART_TERRAIN_" .. _name)
	mod:registerPrefabComponent("models/Terrace1.fbx/Prefab/" .. _name, { DataType = "COMP_RIGID_BODY", Mass = 0 })
	mod:configurePrefabFlagList("models/Terrace1.fbx/Prefab/" .. _name, { "TERRAIN" })
	
	mod:register({
		DataType = "BUILDING_PART",
		Id = "BUILDING_PART_TERRAIN_" .. _name,
		Name = "BUILDING_PART_TERRAIN_" .. _name .. "_NAME", 
		Category = "CORE", 
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
			CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_" .. _name
		}
	})
	
end



-- Function: Piling -------------------------------------------------------------------------------------
function registerPiling(_name)

	mod:registerAssetId("models/Piling1.fbx/Prefab/" .. _name, "PREFAB_BUILDING_PART_TERRAIN_" .. _name)
	mod:registerPrefabComponent("models/Piling1.fbx/Prefab/" .. _name, { DataType = "COMP_RIGID_BODY", Mass = 0 })
	mod:configurePrefabFlagList("models/Piling1.fbx/Prefab/" .. _name, { "TERRAIN" })
	mod:registerPrefabComponent("models/Piling1.fbx/Prefab/" .. _name, { DataType = "COMP_GROUNDED", GroundToWater = true })
	
	mod:register({
		DataType = "BUILDING_PART",
		Id = "BUILDING_PART_TERRAIN_" .. _name,
		Name = "BUILDING_PART_TERRAIN_" .. _name .. "_NAME", 
		Category = "CORE", 
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
			CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_" .. _name
		},
		IsMovableWhenBuilt = true
	})
	
end



-- -- Function: Water -------------------------------------------------------------------------------------
-- function registerWater(_name)

-- 	mod:registerAssetId("models/Terrain1.fbx/Prefab/" .. _name, "PREFAB_BUILDING_PART_TERRAIN_" .. _name)
-- 	mod:registerPrefabComponent("models/Terrain1.fbx/Prefab/" .. _name, { DataType = "COMP_RIGID_BODY", Mass = 0 })
-- 	mod:configurePrefabFlagList("models/Terrain1.fbx/Prefab/" .. _name, { "WATER" })

-- 	mod:register({
-- 		DataType = "BUILDING_PART",
-- 		Id = "BUILDING_PART_TERRAIN_" .. _name,
-- 		Name = "BUILDING_PART_TERRAIN_" .. _name .. "_NAME", 
-- 		Category = "CORE", 
-- 		ConstructorData = {
-- 			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 			CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_" .. _name
-- 		}
-- 	})

-- end



-- Loop -------------------------------------------------------------------------------------
for i= 1, _countHill do
	registerTerrain("HILL" .. i)
end

for i= 1, _countCliff do
	registerTerrain("CLIFF" .. i)
end

for i= 1, _countTerrace do
	registerTerrace("TERRACE" .. i)
end

for i= 1, _countWall do
	registerTerrace("WALL" .. i)
end

for i= 1, _countPiling do
	registerPiling("PILING" .. i)
end



-- Building: Terrain -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_TERRAIN",
	Name = "BUILDING_TERRAIN_NAME",
	Description = "BUILDING_TERRAIN_DESC",
	BuildingType = "DECORATION",
	AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_TERRAIN3_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TERRAIN_WALL1",
				"BUILDING_PART_TERRAIN_WALL2",
				"BUILDING_PART_TERRAIN_WALL3",
				"BUILDING_PART_TERRAIN_TERRACE1",
				"BUILDING_PART_TERRAIN_TERRACE2",
				"BUILDING_PART_TERRAIN_TERRACE3",
				"BUILDING_PART_TERRAIN_WALL4",
			}
		},
		{
			Name = "BUILDING_SET_TERRAIN4_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TERRAIN_PILING1",
				"BUILDING_PART_TERRAIN_PILING2",
				"BUILDING_PART_TERRAIN_PILING3",
			}
		},
		{
			Name = "BUILDING_SET_TERRAIN1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TERRAIN_HILL1",
				"BUILDING_PART_TERRAIN_HILL2",
				"BUILDING_PART_TERRAIN_HILL3",
				"BUILDING_PART_TERRAIN_HILL4",
				"BUILDING_PART_TERRAIN_HILL5",
				"BUILDING_PART_TERRAIN_HILL6",
				"BUILDING_PART_TERRAIN_HILL7",
				"BUILDING_PART_TERRAIN_HILL8",
				"BUILDING_PART_TERRAIN_HILL9",
				"BUILDING_PART_TERRAIN_HILL10",
				"BUILDING_PART_TERRAIN_HILL11",
				"BUILDING_PART_TERRAIN_HILL12",
				"BUILDING_PART_TERRAIN_HILL13",
				"BUILDING_PART_TERRAIN_HILL14",
				"BUILDING_PART_TERRAIN_HILL15",
			}
		},
		{
			Name = "BUILDING_SET_TERRAIN2_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TERRAIN_CLIFF1",
				"BUILDING_PART_TERRAIN_CLIFF2",
				"BUILDING_PART_TERRAIN_CLIFF3",
				"BUILDING_PART_TERRAIN_CLIFF4",
				"BUILDING_PART_TERRAIN_CLIFF5",
			}
		},
	},	
	RequiredPartList = {
	},
	IsEditable = true,
	MaterialSetList = {
		{
			SetName = "MATERIAL_SET_TERRAIN1_NAME",
			MaterialList = {
				"MATERIAL_TERRAIN_GRASS",
				"MATERIAL_TERRAIN_ROCK",
			}
		},
		{
			SetName = "MATERIAL_SET_TERRAIN2_NAME",
			MaterialList = {
				"MATERIAL_TERRAIN_DARK",
				"MATERIAL_TERRAIN_ROCK",
			}
		},
		{
			SetName = "MATERIAL_SET_TERRAIN3_NAME",
			MaterialList = {
				"MATERIAL_TERRAIN_LIGHT",
				"MATERIAL_TERRAIN_ROCK",
			}
		},
	}
})


